; LINK PORT SENDING AND RECEIVING
; Thanks to Pascal Bouron

;
;            Rece_byte
;
; INPUT   : no
; OUTPUT  : a           = Read byte value
Rece_By:
 push bc
 push de
 ld    e,1       ; for the OR
 ld    c,0       ; byte receive
 ld    b,8       ; counter
 ld    a,$C0
 out   (7),a
rb_w_Start:
 in    a,(7)
 and 3
 cp  3
 jr    nz,rb_get_bit
 CALL_(Test_ON)
 jr    rb_w_Start	;Attend le un bit
rb_get_bit:
 cp    2
 jr    z,rb_receive_zero
 ld    a,c
 or    e
 ld    c,a
 ld    a,$D4
 out   (7),a
 jr    rb_waitStop
rb_receive_zero:
 ld    a,$E8
 out   (7),a
rb_waitStop:
 CALL_(Test_ON)
 in    a,(7)
 and   3
 jr    z,rb_waitStop
 ld    a,$c0
 out   (7),a
 rl    e
 djnz	rb_w_Start
 ld    a,c
 pop de
 pop bc
 ret


;
;            Send_byte
;
; INPUT   : a
; OUTPUT  : no
Send_By:
 push  bc
 ld    b,8
 ld    c,a	;byte to send
 ld    a,$C0
 out   (7),a
w_setport3:
 in    a,(7)
 and 3
 cp  3
 jr    z,calc_bit
 CALL_(Test_ON1)
 jr    w_setport3	;Attend le Setport(3)
calc_bit:
 ld    a,c
 and   1
 jr    z,send_one
send_zero1:
 ld    a,$E8
 out   (7),A
 jr    wait_setport
send_one:
 ld    a,$D4
 out   (7),A
wait_setport:
 CALL_(Test_ON1)
 in    a,(7)
 and   3
 jr    nz,wait_setport 	;Attend le Setport
 ld    a,$C0
 out   (7),A
 srl c
 djnz w_setport3
 pop bc
 ret

;
;               Test_ON
;
; INPUT   : no
; OUTPUT  : a = Last key pressed
; rem : Go to Choix if [ON] Pressed
Test_ON:
 in     a,(3)
 and    8
 ret    nz
Retour_choix:
 pop  	bc
 pop  	hl
 JUMP_(LinkError)

Test_ON1:
 in     a,(3)
 and    8
 ret    nz
Retour:
 pop 	bc
 JUMP_(LinkError)
